From 0489527aece22c4819072ce2cecdcbfbdf587839 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 27 2020 21:41:42 +0000
Subject: [PATCH 937/2232] Combine buck codegen steps into one run of cxxbridge


---

diff --git a/tools/buck/rust_cxx_bridge.bzl b/tools/buck/rust_cxx_bridge.bzl
index ba9d8f1..4acc7c6 100644
--- a/tools/buck/rust_cxx_bridge.bzl
+++ b/tools/buck/rust_cxx_bridge.bzl
@@ -3,17 +3,21 @@ load("//tools/buck:genrule.bzl", "genrule")
 def rust_cxx_bridge(name, src, deps = []):
     genrule(
         name = "%s/header" % name,
-        srcs = [src],
         out = src + ".h",
-        cmd = "$(exe //:codegen) ${SRCS} -o ${OUT}",
-        type = "cxxbridge",
+        cmd = "cp $(location :%s/generated)/generated.h ${OUT}" % name,
     )
 
     genrule(
         name = "%s/source" % name,
-        srcs = [src],
         out = src + ".cc",
-        cmd = "$(exe //:codegen) ${SRCS} -o ${OUT}",
+        cmd = "cp $(location :%s/generated)/generated.cc ${OUT}" % name,
+    )
+
+    genrule(
+        name = "%s/generated" % name,
+        srcs = [src],
+        out = ".",
+        cmd = "$(exe //:codegen) ${SRCS} -o ${OUT}/generated.h -o ${OUT}/generated.cc",
         type = "cxxbridge",
     )
 

